Attribute VB_Name = "Sample"
'============================================================================
'  aisa45s.bas
'
'  aISA-A45
'
'  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'  Date 1998/11/11
'
'  ̿ɂׯ߰֐̎gpႪLqĂ܂B
'
'============================================================================
Option Explicit
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long

Global Const WM_AISA_INTERRUPT = &H6000
Private Const WM_AISA45_EOC = WM_AISA_INTERRUPT + WM_EOC
Private Const WM_AISA45_BUFF_HALF_FULL = WM_AISA_INTERRUPT + WM_BUFF_HALF_FULL
Private Const WM_AISA45_BUFF_FULL = WM_AISA_INTERRUPT + WM_BUFF_FULL
Private Const WM_AISA45_BUFF_OVERFLOW = WM_AISA_INTERRUPT + WM_BUFF_OVERFLOW
Private Const WM_AISA45_SAMPLING_OVERRUN = WM_AISA_INTERRUPT + WM_SAMPLING_OVERRUN

Private Const GWL_WNDPROC = -4
Private lpPrevWndProc As Long
Global gwLogSlot As Integer

'============================================================================
'  aisa45.dll ̎gp錾gp޲T
'============================================================================
Function Aisa45sCreate(pwLogSlot As Integer, ByVal hwnd As Long, ByVal uWMBase As Long) As Long
  Dim szBuf As String
  Dim Result As Boolean
  lpPrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WindowProc)
  '-------------------------------------------------
  '  aisa45.dll̎gp錾
  '-------------------------------------------------
  Result = Aisa45wDllOpen()
  If Result = True Then
    '-------------------------------------------------
    '  gp޲TAۯĔԍ\܂
    '-------------------------------------------------
    pwLogSlot = AISA45_SLOT_AUTO
    Result = Aisa45wCreate(pwLogSlot, hwnd, uWMBase)
    If Result = True Then
      szBuf = "aISA-A45 Created" + Chr(10) + Chr(10) + "LogSlot: " + Str(pwLogSlot)
      ResultMessage (szBuf)
    Else
      Aisa45wDllClose
    End If
  End If
  '-------------------------------------------------
  '  װȂ\
  '-------------------------------------------------
  If Result <> True Then
    ErrorMessage (AISA45_SLOT_AUTO)
    pwLogSlot = AISA45_SLOT_AUTO
  End If
  Aisa45sCreate = Result
End Function
'============================================================================
'  aISA-A45̎gpJ
'============================================================================
Function Aisa45sClose(ByVal wLogSlot As Integer, ByVal hwnd As Long) As Boolean
  Dim Result As Boolean
  Dim temp As Long
  Result = True
  If wLogSlot <> AISA45_SLOT_AUTO Then
    '-------------------------------------------------
    '  aISA-A45̎gpJ
    '-------------------------------------------------
    If Aisa45wClose(wLogSlot) <> True Then
      ErrorMessage (AISA45_SLOT_AUTO)
      Result = False
    End If
    '-------------------------------------------------
    '  aisa45.dll ̎gpJ
    '-------------------------------------------------
    If Aisa45wDllClose() <> True Then
      MsgBox "DLL ̃A[hɎs܂", vbOKOnly + vbCritical
      Result = False
    End If
  End If
  temp = SetWindowLong(hwnd, GWL_WNDPROC, lpPrevWndProc)
  Aisa45sClose = Result
End Function
'============================================================================
'  aISA-A45ؿ擾\
'============================================================================
Function Aisa45sGetResource(ByVal wLogSlot As Integer) As Boolean
  Dim Ri As AISA45RESOURCE
  Dim dwDLLVer As Long, dwVxdVer As Long
  Dim szBuf As String
  Dim Result As Boolean

  '-------------------------------------------------
  '  aISA-A45ؿ擾
  '-------------------------------------------------
  Result = Aisa45wGetResource(wLogSlot, Ri)
  If Result = True Then
    szBuf = "Board Name: aISA-A45" + Chr(10) + _
            "NumPorts: " + Str(Ri.dwIOPortLength(1)) + Chr(10) + _
            "IO Address: &H" + Hex(Ri.dwIOPortBase(1)) + _
            "-&H" + Hex(Ri.dwIOPortBase(1) + Ri.dwIOPortLength(1) - 1)
    ResultMessage (szBuf)
    '-------------------------------------------------
    '  aISA-A45 DLL,VxDްޮݔԍ擾ƕ\
    '-------------------------------------------------
    Result = Aisa45wGetVersion(dwDLLVer, dwVxdVer)
    If Result = True Then
      szBuf = "GetVersion" + Chr(10) + _
               "DLL    Version: &H" + Hex(dwDLLVer) + Chr(10) + _
               "Driver Version: &H" + Hex(dwVxdVer)
      ResultMessage (szBuf)
    End If
  End If
  '-------------------------------------------------
  '  װȂ\
  '-------------------------------------------------
  If Result <> True Then
    ErrorMessage (wLogSlot)
  End If
  Aisa45sGetResource = Result
End Function
'============================================================================
'  aISA-A45߰Ă͂\
'============================================================================
Function Aisa45sInPort(ByVal wLogSlot As Integer) As Boolean
  Dim wBotn As Integer
  Dim cbDat As Byte
  Dim szBuf As String
  Dim Result As Boolean

  '-------------------------------------------------
  '  aISA-A45߰Ă͂ް\
  '-------------------------------------------------
  Do
    wBotn = vbYes
    Result = Aisa45wInPort(wLogSlot, cbDat)
    If Result = True Then
      szBuf = "߰ē" + Chr(10) + "Port In Data: &H" + Hex(cbDat) + Chr(10) + _
              Chr(10) + "ē͂܂"
      wBotn = MsgBox(szBuf, vbYesNo)
    End If
  Loop Until (wBotn <> vbYes) Or (Result <> True)
  '-------------------------------------------------
  '  װȂ\
  '-------------------------------------------------
  If Result <> True Then
    ErrorMessage (wLogSlot)
  End If
  Aisa45sInPort = Result
End Function
'============================================================================
'  aISA-A45A/DJn
'============================================================================
Function Aisa45sStartSample(ByVal wLogSlot As Integer) As Boolean
  Dim Md As AISA45MODE
  Dim Result As Boolean

  '-------------------------------------------------
  '  ݸӰނݒ肵ݸފJn
  '-------------------------------------------------
  Md.dwMode = 2
  Md.dwChFirst = 0
  Md.dwChLast = 31
  Md.cwBuffer = 32 * 2
  Md.dwTimer = &H14               '20mSϰ
  Result = Aisa45wSetMode(wLogSlot, Md)
  If Result = True Then
      Result = Aisa45wStartSampling(wLogSlot)
  End If
  '-------------------------------------------------
  '  װȂ\
  '-------------------------------------------------
  If Result <> True Then
    ErrorMessage (wLogSlot)
  End If
  Aisa45sStartSample = Result
End Function
'============================================================================
'  aISA-A45A/D͂\
'============================================================================
Function Aisa45sGetData(ByVal wLogSlot As Integer) As Boolean
  Dim cwNumData As Long
  Dim cwNum As Long
  Dim dwStatus As Long
  Dim wData() As Integer
  Dim szBuf As String
  Dim wBotn As Integer
  Dim Result As Boolean

  '-------------------------------------------------
  '  ݸސ擾ݸް̈m
  '-------------------------------------------------
  Result = Aisa45wGetSamplingStatus(wLogSlot, cwNumData, dwStatus)
  If (Result = True) And (cwNumData > 0) Then
    ReDim wData(cwNumData)
    '-------------------------------------------------
    '  ݸް擾ĕ\ް쐬
    '-------------------------------------------------
    Result = Aisa45wGetData(wLogSlot, cwNumData, wData(0))
    If Result = True Then
      szBuf = "A/Dް" + " LogSlot:" + Str(wLogSlot)
      For cwNum = 0 To (cwNumData - 1) Step 1
        If 0 = (cwNum Mod 4) Then
          szBuf = szBuf + Chr(10)
        End If
        szBuf = szBuf + Chr(9) + "CH" + Right$(Str(cwNum + 1), 2) + _
                ":" + Right$("000" + Hex(wData(cwNum)), 3)
      Next cwNum
      '-------------------------------------------------
      '  ݸް\čē͂邩mF
      '-------------------------------------------------
      szBuf = szBuf + Chr(10) + Chr(10) + "ē͂܂"
      wBotn = MsgBox(szBuf, vbYesNo)
      If ((wBotn = vbYes) And (Result = True)) Then
        Result = Aisa45sStartSample(wLogSlot)
      Else
        Unload SampleForm
      End If
    End If
  End If
  '-------------------------------------------------
  '  װȂ\
  '-------------------------------------------------
  If Result <> True Then
    ErrorMessage (wLogSlot)
    Unload SampleForm
  End If
  Aisa45sGetData = Result
End Function
'============================================================================
'    үޏ
'============================================================================
Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Select Case uMsg
    '-------------------------------------------------
    '  EOC 荞ݔүޏ
    '-------------------------------------------------
    Case WM_AISA45_EOC
      Aisa45wStopSampling (wParam)
      Aisa45sGetData (wParam)
    '-------------------------------------------------
    '  Half 荞ݔүޏ
    '-------------------------------------------------
    Case WM_AISA45_BUFF_HALF_FULL
      Aisa45wStopSampling (wParam)
      Aisa45sGetData (wParam)
    '-------------------------------------------------
    '  Full 荞ݔүޏ
    '-------------------------------------------------
    Case WM_AISA45_BUFF_FULL
      Aisa45wStopSampling (wParam)
      Aisa45sGetData (wParam)
    '-------------------------------------------------
    '  ޯ̧ް۰ 荞ݔүޏ
    '-------------------------------------------------
    Case WM_AISA45_BUFF_OVERFLOW
      Aisa45wStopSampling (wParam)
      MsgBox "LogSlot:" + Str(wParam) + " ޯ̧ް۰װ܂", vbOKOnly + vbCritical
      Unload SampleForm
    '-------------------------------------------------
    '  ް 荞ݔүޏ
    '-------------------------------------------------
    Case WM_AISA45_SAMPLING_OVERRUN
      Aisa45wStopSampling (wParam)
      MsgBox "LogSlot:" + Str(wParam) + " ްݥװ܂", vbOKOnly + vbCritical
      Unload SampleForm
   End Select
   WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function
'============================================================================
'    ʂ\
'============================================================================
Sub ResultMessage(lpszbuf As String)
  MsgBox lpszbuf, vbOKOnly + vbInformation
End Sub
'============================================================================
'    G[bZ[W\
'============================================================================
Sub ErrorMessage(ByVal wLogSlot As Integer)
  Dim dwRes As Integer
  Dim szBuf As String

  dwRes = Aisa45wGetLastError(wLogSlot)
  Select Case dwRes
    Case AISA45_ERR_SYSTEM
      szBuf = "System error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(GetLastError())
    Case AISA45_ERR_WRAPDLL
      szBuf = "DLL Load error"
    Case Else
      szBuf = "aISA-A45 error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(dwRes)
  End Select
  MsgBox szBuf, vbOKOnly + vbCritical
End Sub

